//ITTT PHIL POT
//Procrastinate no more, Uitstelleritus Deletus is here!
//---------------------------------------------------------

//LCD
#include <LiquidCrystal.h>

//TIMER
//CHANGE TIME HERE!
//you also need to change this
int S = 59;  // count seconds
int M = 4;   // count minutes
int H = 0;   // count hours

//initialize the library with the numbers of the interface pins
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

//BUTTON
#define BUTTON 6  //button to arduino pin 6
int buttonState = 0;
int buttonCount = 0;

//BUZZER
const int BUZZER = 9;  //buzzer to arduino pin 9

void setup() {
  //communication with the arduino
  Serial.begin(9600);

  //LCD
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);

  // Print a message to the LCD.
  lcd.setCursor(0, 0);
  lcd.print("VMPR");  //that's me :-}
  lcd.setCursor(0, 1);
  lcd.print("Presents...");
  delay(1500);
  lcd.clear();

  //*drumroll*
  lcd.setCursor(0, 0);
  lcd.print("Uitstelleritus");
  lcd.setCursor(0, 1);
  lcd.print("Deletus");
  //uitstelleritus deletus!

  //BUTTON
  pinMode(BUTTON, INPUT);  // Set button as an input

  //BUZZER
  pinMode(BUZZER, OUTPUT);  // Set buzzer as an output
}

void loop() {
  
  //get input from button
  buttonState = digitalRead(BUTTON);

  if (buttonState == HIGH) {
    buttonCount++;
  }

  Serial.print("buttoncount : ");
  Serial.println(buttonCount);

  //START TIMER WHEN BUTTON IS PRESSED
  if (buttonCount == 1) {
    lcd.clear();
    lcd.setCursor(3, 0);
    lcd.print("OR ELSE...");
    lcd.setCursor(6, 1);
    lcd.print(":");
    lcd.setCursor(9, 1);
    lcd.print(":");

    //TIMER
    while (S >= 0 || M >= 0 || H >= 0) {
      lcd.setCursor(7, 1);
      lcd.print((M > 9) ? M : ("0" + String(M)));
      lcd.setCursor(10, 1);
      lcd.print((S > 9) ? S : ("0" + String(S)));
      lcd.setCursor(12, 1);
      lcd.print(" ");

      //ON A FAIL
      if (S == 0 && M == 0 && H == 0) {
        lcd.clear();
        lcd.setCursor(4, 0);
        lcd.print("LOSER!!!");
        lcd.setCursor(1, 1);
        lcd.print(">:-( >:-( >:-(");

        delay(2000);
        break;  // Exit the while loop
      }

      //COUNTDOWN
      S--;
      if (S < 0) {
        M--;
        S = 59;
        if (M < 0) {
          H--;
          M = 59;
        }
      }

      lcd.setCursor(4, 1);
      lcd.print((H > 9) ? H : ("0" + String(H)));
      lcd.setCursor(6, 1);
      lcd.print(":");
      delay(1000);

      buttonState = digitalRead(BUTTON_PIN);

      if (buttonState == HIGH) {
        buttonCount++;
      }

      if (buttonCount == 2) {
        break;  // Exit the while loop if buttonCount reaches 2
      }
    }

    //ON A SUCCES
    //ONCE BUTTON IS PRESSED A LOT OF TIMES TO SIGNIFY BEING HAPPY YOU FINISHED
    if (buttonCount >= 2) {
      lcd.clear();
      lcd.setCursor(3, 0);
      lcd.print("Well done");
      lcd.setCursor(2, 1);
      lcd.print("nice guy :-)");
      delay(2500);
      lcd.clear();
      lcd.setCursor(3, 0);
      lcd.print("Restart..?");
      lcd.setCursor(1, 1);
      lcd.print("Press up top !");
    }
  }
}